﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.Linq;
using System.Web;

namespace Gallery_ImageBindC
{
    /// <summary>
    /// Summary description for ImageHandler
    /// </summary>
    public class ImageHandler : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            OleDbDataAdapter adap = new OleDbDataAdapter("Select * from Categories", new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\\C1NWind.mdb;Persist Security Info=True"));
            DataSet ds = new DataSet();
            adap.Fill(ds);
            DataTable dt = ds.Tables[0];
            HttpRequest request = context.Request;
            if (!string.IsNullOrEmpty(request.QueryString["id"]))
            {
                int rindex = Convert.ToInt32(request.QueryString["id"]);
                byte[] picData = (byte[])dt.Rows[rindex][3];
                if (picData != null)
                {
                    // is this is an embedded object?
                    int bmData = (picData[0] == 0x15 && picData[1] == 0x1c) ? 78 : 0;
                    // load the picture
                    System.Drawing.Image b = null;
                    try
                    {
                        System.IO.MemoryStream ms = new System.IO.MemoryStream(picData, bmData, picData.Length - bmData);
                        b = System.Drawing.Image.FromStream(ms);
                        System.Drawing.Bitmap bitMap = new System.Drawing.Bitmap(b, b.Width, b.Height);
                        //changing content type of handler page
                        context.Response.ContentType = "image/jpeg";
                        bitMap.Save(context.Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
                        bitMap.Dispose();
                    }
                    catch
                    {
                    }
                }
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}